(define-condition dziedzina (error)
  ((text :initarg :text :reader text)))
  



(defun pierw(x)
   (when (< x 0)
      (error 'dziedzina :text "sqrt - ujemny argent")
   )
  (sqrt x)
)

(print (pierw 4))

;(print (pierw -4))


(defun troj (a b c)
  (restart-case
    (let ((d (pierw (- (* b b) (* 4 a c)))))
      (list (/ (-    d  b) 2 a) 
    	    (/ (- (- d) b) 2 a)
      )
    )
    (brakrozwiazan () "Brak rozwiązań")    
    (pustalista () ())    
    (podajb () (print 'b=) (troj a (read) c))
  )
)

(defun test()
    (print (troj 1 2 1))
    (print (troj 1 3 1))
    (print (troj 1 1 1))
)

(defun test1()
  (handler-bind (
                  (dziedzina (lambda (x) (invoke-restart 'brakrozwiazan)) )
                )
    (test)
  )
)


(defun test2()
  (handler-bind (
                  (dziedzina (lambda (x) (invoke-restart 'pustalista)) )
                )
    (test)
  )
)

(defun test3(restart)
   (handler-bind (
                  (dziedzina (lambda (x) (invoke-restart restart)) )
                )
    (test)
  )
)

(defun test4(&key (restart 'pustalista))
   (handler-bind (
                  (dziedzina (lambda (x) (invoke-restart restart)) )
                )
    (test)
  )
)

