(defclass punkt()
  (
   (x :initarg :x 
    :initform 0
    :accessor x
   ) 
   (y :initarg :y
    :initform 0
    :accessor y
    )
   )
)
(defclass kolo(punkt)
    ((r :initarg :r 
    :initform 0
    :accessor r
    ))
)
(defclass kwadrat(punkt)
    ((a :initarg :a 
    :initform 0
    :accessor a
    ))

)

(setf aa (make-instance 'punkt))


(defgeneric odl  (a b)
(:documentation "Odległość")
;(:method-combination +)
(:method ((a punkt) (b punkt)) 
   (let ((dx (- (x a) (x b)))
         (dy (- (y a) (y b)))
        ) 
    (sqrt (+ (* dx dx) (* dy dy)))
   )
)

(:method ((a kolo) (b punkt)) 
  (max 0 (- (call-next-method) (r a))) 
)


(:method ((a punkt) (b kolo)) 
 ; (max 0 (- (call-next-method) (r b))) 
  (odl b a) 
)

(:method ((a (eql aa)) b ) 
  0
)


)


(setf a (make-instance 'punkt :x 1))
(setf b (make-instance 'punkt :y 1))
(setf k (make-instance 'kolo :r 0.5))

(print (odl a b))
(print (odl k a))
(print (odl b k))

(print (odl aa a))


